#ifndef BASE_H_
#define BASE_H_

/*
Equivalent of defining:
  class Base {
   public:
    virtual void foo();
    virtual void bar();
    int x_;
  };
*/

typedef struct base_st {
  void (**vtable_)(void*);  // Have parameter be void* instead of Base* to avoid compiler complaining too much
  int x_;
} Base;

void base_foo(Base* this);
void base_bar(Base* this);

extern void (*base_vtable[])(void*);

#endif  // BASE_H_
