#ifndef DERIVED_H_
#define DERIVED_H_

#include "./Base.h"

/*
Equivalent of defining:
  class Derived : public Base {
   public:
    void foo();  // virtual is sticky
    virtual void baz();
    int y_;
  };
*/

typedef struct derived_st {
  Base base_;
  int y_;
} Derived;

void derived_foo(Derived* this);
void derived_baz(Derived* this);

extern void (*derived_vtable[])(void*);

#endif  // DERIVED_H_
